#!/usr/bin/perl
################################################################################
# WAccess                                      Version 1.1                     #
# Copyright 1999 Frederic TYNDIUK (FTLS)       All Rights Reserved.            #
# E-Mail: tyndiuk@ftls.org                     Script License: GPL             #
# Created  05/30/98                            Last Modified 12/24/99          #
# Scripts Archive at:                          http://www.ftls.org/cgi/        #
################################################################################
# Function :                                                                   #
# Display Administrative page                                                  #
# Use : admin.cgi                 : query login, pass and display member page  #
# if good login and pasword :                                                  #
# admin.cgi?login=YourLogin&pass=YourPassword : display admin page             #
# admin.cgi?login=YourLogin&pass=YourPassword&ac=admin  : admin users          #
# admin.cgi?login=YourLogin&pass=YourPassword&ac=chpass : change password      #
################################################################################
########################## license & copyright header ##########################
#                                                                              #
#                     Copyright (c) 1999 by TYNDIUK Frederic                   #
#                                                                              #
#       This program is free software; you can redistribute it and/or          #
#       modify it under the terms of the GNU General Public License as         #
#       published by the Free Software Foundation; either version 2 of         #
#       the License, or (at your option) any later version.                    #
#                                                                              #
#       This program is distributed in the hope that it will be useful,        #
#       but WITHOUT ANY WARRANTY; without even the implied warranty of         #
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          #
#       GNU General Public License for more details.                           #
#                                                                              #
#       You should have received a copy of the GNU General Public License      #
#       along with this program in the file 'COPYING'; if not, write to        #
#       the Free Software Foundation, Inc., 59 Temple Place - Suite 330,       #
#       Boston, MA 02111-1307, USA, or contact the author:                     #
#                                                                              #
#                                   TYNDIUK Frederic <tyndiuk@ftls.org>        #
#                                            <http://www.ftls.org/>            #
#                                                                              #
######################## end license & copyright header ########################
################################################################################
#    DO NOT EDIT ANYTHING BELOW THIS LINE UNLESS YOU KNOW WHAT YOU'RE DOING    #
################################################################################

require 'WAccessLib.pl';

&ReadParse(*input);

my $login = $input{'login'};
my $password = $input{'pass'};
my $action = $input{'ac'};

if ($input{'BT_Exit'}) { $action = ""; }

if ($action eq "admin") {
	&admin();
} elsif ($action eq "chpass") {
	&change_password($login, $password, %input);
} else {
	&CheckAdminMember($login, $password, "root", $ADMIN_FILE);
}

sub admin {
	my ($name, $pw, $level, $file);
	print &PrintHeader;
	if (! &check_password("root",$login, $password)) {
		print &BadPassword($NAME_TITLE{'common_admin'});
		exit;
	}
	$action = "admin";	

	if ($input{'BT_AddUser'}) {
		print &HTMLHeaderTitle("$NAME_TITLE{'common_admin'}<BR>$NAME_TITLE{'add_user'}");
		print "<CENTER><FORM METHOD=post><INPUT TYPE=HIDDEN Name=ac VALUE=$action><INPUT TYPE=HIDDEN Name=login VALUE=$login><INPUT TYPE=HIDDEN Name=pass VALUE=$password><TABLE BORDER=0>\n";
		print "<TR><TD>$NAME_HEADTAB{'new_login'} :</TD><TD><INPUT TYPE=text Name=NewLogin></TD></TR>\n";
		print "<TR><TD>$NAME_HEADTAB{'new_pass'} :</TD><TD><INPUT TYPE=Password Name=NewPass></TD></TR>\n";
		print "<TR><TD>$NAME_HEADTAB{'conf_pass'} :</TD><TD><INPUT TYPE=Password Name=ConfPass></TD></TR>\n";
		print "<TR><TD>$NAME_HEADTAB{'level'} :</TD><TD><INPUT TYPE=Radio Name=Mode Value=root>$NAME_HEADTAB{'admin'} <INPUT TYPE=Radio Name=Mode Value=guest CHECKED>$NAME_HEADTAB{'member'}</TD></TR>\n";
		print "<TR><TD>$NAME_HEADTAB{'user_page'} :</TD><TD><INPUT TYPE=Text Name=Page></TD></TR>\n";
		print "<TD></TD><TD ALIGN=\"CENTER\"><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'add'} \" NAME=BT_Add> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'exit'} \" NAME=BT_Exit></TD></TR>\n";
		print "</TABLE></CENTER></FORM>\n";
		print &HTMLEnd;
		exit;
	} 

	if ($input{'BT_Add'}) {
		if (($input{'NewPass'} eq $input{'ConfPass'}) && ($input{'NewPass'} ne "") && ($input{'NewLogin'} ne "")) {
			open(PASSWORD, ">>$PASSWORD_FILE") || &Error("Cannot write password file: $PASSWORD_FILE, Error: $!",1);
			print PASSWORD ("$input{'NewLogin'}\t".CryptPassword($input{'NewPass'})."\t$input{'Mode'}\t$input{'Page'}\n");
			close PASSWORD;
			$NAME_TITLE{'user_added'} =~ s/Value_login/$input{'NewLogin'}/gi;
			print &ResutPage("$NAME_TITLE{'common_admin'}<BR>$NAME_TITLE{'user_added'}", "", $action, $login, $password);
		} else {
			print &ResutPage("$NAME_TITLE{'common_admin'}<BR>$NAME_TITLE{'error'} : $NAME_TITLE{'add_user'}", $HELP_TEXT{'error_adduser'}, $action, $login, $password);
		}
		exit;
	}

	if ($input{'BT_DelUser'} && ($input{'No'} >= 0)) {
		open(PASSWORD, "$PASSWORD_FILE") ||  &Error("Cannot open password file : $PASSWORD_FILE, Error: $!\n",1);
		@pass = <PASSWORD>;
		close PASSWORD;
	    ($name) = split /\t/, splice(@pass, $input{'No'}, 1);
		open(PASSWORD, ">$PASSWORD_FILE") || &Error("Cannot write password file: $PASSWORD_FILE, Error: $!",1);
		print PASSWORD @pass;
		close PASSWORD;
		$NAME_TITLE{'user_deleted'} =~ s/Value_new_login/$name/;
		print &ResutPage("$NAME_TITLE{'common_admin'}<BR>$NAME_TITLE{'user_deleted'}","", $action, $login, $password);
		exit;
	}

	print &HTMLHeaderTitle("$NAME_TITLE{'common_admin'}<BR>$NAME_TITLE{'manage_users'}");
	print "<CENTER><FORM METHOD=post><INPUT TYPE=HIDDEN Name=ac VALUE=$action><INPUT TYPE=HIDDEN Name=login VALUE=$login><INPUT TYPE=HIDDEN Name=pass VALUE=$password>\n";
	print "<TABLE BORDER=1 WIDTH=70%><TR><TD></TD><TH> $NAME_HEADTAB{'name'} </TH><TH> $NAME_HEADTAB{'level'} </TH><TH> $NAME_HEADTAB{'user_page'} </TH></TR>\n";
	open(PASSWORD, "$PASSWORD_FILE") || &Error("Cannot open password file: $PASSWORD_FILE, Error: $!",1);
	@PassFile = <PASSWORD>;
	close(PASSWORD);
	$cnt = 0;
	foreach (@PassFile) {
		if (! /\s*^#/) {
			($name, $pw, $level, $file) = split /\t/;
			print "<TR><TD ALIGN=\"CENTER\"><INPUT TYPE=radio Name='No' Value='$cnt' </TD><TD> $name </TD><TD> $level </TD><TD> $file </TD></TR>\n";
		}
		$cnt++;
	}
	print "</TABLE><BR><INPUT TYPE=Submit Value=\" $NAME_BUTTON{'del_user'} \" NAME=BT_DelUser> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'add_user'} \" NAME=BT_AddUser> <INPUT TYPE=Submit Value=\" $NAME_BUTTON{'exit'} \" NAME=BT_Exit></CENTER></FORM>\n";
	print &HTMLEnd;
}
